Index: /library/bdm/bdmroot.h
===================================================================
--- /library/bdm/bdmroot.h (revision 769)
+++ /library/bdm/bdmroot.h (revision 789)
@@ -18,6 +18,13 @@
 
 #include "itpp_ext.h"
-#include "base/libconfig/lib/libconfig.h++"
 #include "bdmerror.h"
+
+#ifdef MEX
+	#include "base/libconfig/lib/libconfig.h++"	
+	// TODO DODELAT A NAHRADIT #include "base/libconfig_mex.h"
+#else
+	#include "base/libconfig/lib/libconfig.h++"
+#endif
+
 
 using namespace libconfig;
@@ -26,8 +33,7 @@
 
 namespace bdm {
-
-	
-	//! auxiliary function for debugging
-	void UI_DBG (const Setting &S, const string &spc, ostream &out );
+	
+//! auxiliary function for debugging
+void UI_DBG (const Setting &S, const string &spc, ostream &out );
 	
 //forward declaration
@@ -54,16 +60,82 @@
 	int log_level;
 
-	//! It is necessary to allow calling of from_setting and to_setting within the user_info class
+	//! It is necessary to allow calling of from_setting and to_setting within the UI class
 	friend class UI;
 
-	//! Read instance properties according the data stored in the Setting structure
-	//! 
-	//! It has to be called only through user_info class, therefore it is protected 
+	/*!	
+	\brief Read instance properties according the data stored in the Setting structure.
+	It has to be called only through UI class, therefore it is protected 
+
+	At the begining of this method, it is obligatory to call
+	the corresponding base::from_setting method. Sometimes, there can be 
+	an exception from this rule. If so, the programmer is encouraged 
+	to describe the reasons for this exception in the documentation in detail.
+	
+	Then, all the configuration	components should be read through the UI mechanism. 
+	Those with UI::SettingPresence set to optional shoud have their defaults fulfilled 
+	within the body of this method.
+
+	For instance, declaring a class \c trunk derived from our #root class, 
+	the implementation of the from_setting method should look like this
+
+	\code
+
+	public trunk : public root {
+
+		anytype xxx, yyy;
+
+		virtual void from_setting ( const Setting &set ) {
+			root::from_setting( set );
+			
+			UI::get ( xxx, set, "xxx", UI::compulsory );
+
+			if ( !UI::get ( yyy, set, "yyy", UI::optional ) ) {
+				... // here, it is necessary to set the default of attribute yyy						
+			}
+
+			... // another stuff related to trunk class
+		}
+
+		... // other members of this class
+	};
+
+	\endcode
+	*/
 	virtual void from_setting ( const Setting &set ) {
 	}
 
-	//! Save all the instance properties into the Setting structure
-	//!
-	//! It has to be called only through user_info class, therefore it is protected 
+	/*!	
+	\brief 	Save all the instance properties into the Setting structure.
+	It has to be called only through UI class, therefore it is protected 
+
+	The only obligatory rule concerning the body of this method is to call
+	the corresponding base::to_setting method first. 	Sometimes, there can 
+	be an exception from this rule. If so, the programmer is encouraged 
+	to describe the reasons for this exception in the documentation in detail.
+	
+	For instance, declaring
+	a class \c trunk derived from our #root class, the implementation of 
+	the to_setting method should look like this
+
+	\code
+	public trunk : public root {
+
+		anytype xxx;
+
+		virtual void to_setting ( const Setting &set ) {
+			root::to_setting( set );
+
+			UI::save ( xxx, set, "xxx" );
+			
+			... // another stuff related directly to trunk class
+
+		}
+
+		... // other members of this class
+
+	};
+
+	\endcode
+	*/
 	virtual void to_setting ( Setting &set ) const {
 	}
@@ -101,5 +173,36 @@
 	}
 
-	//! Check that all internal structures has been correctly set-up. Called at the end of from_setting.
+	/*!	
+	\brief 	This method checks that all internal structures has been set up correctly.
+
+	It is called automatically after the call of the #from_setting method by the mechanism of the UI class. 
+	However, it can be called in any other situation to assure the correctness of an instance.
+	
+	The only obligatory rule concerning the body of this method is to call
+	the corresponding base::validate method first. Sometimes, there can be 
+	an exception from this rule. If so, the programmer is encouraged 
+	to describe the reasons for this exception in the documentation in detail.	
+	
+	Then, only those checks which are not implemented in the base method 
+	are implemented here. For instance, declaring a class \c trunk derived from our 
+	#root class, the implementation of the method validate should 
+	look like this
+
+	\code
+	public trunk : public root {
+
+		virtual void validate ( ) {
+			root::validate( );
+
+			... // checks related directly to trunk class
+		}
+
+		... // other members of this class
+
+	};
+
+	\endcode
+
+	*/
 	virtual void validate() {
 	}
@@ -108,10 +211,8 @@
 	virtual root* _copy() const NOT_IMPLEMENTED(NULL);
 	
-
 	//! access function
 	int _log_level() const {
 		return log_level;
 	}
-
 };
 
Index: /library/bdm/base/user_info.h
===================================================================
--- /library/bdm/base/user_info.h (revision 771)
+++ /library/bdm/base/user_info.h (revision 789)
@@ -22,9 +22,7 @@
 #include <stdexcept>
 
-#include "libconfig/lib/libconfig.h++"
 #include "../bdmroot.h"
 #include "../shared_ptr.h"
 #include "itpp/itbase.h"
-
 
 using std::string;
Index: /library/bdm/base/libconfig_mex.h
===================================================================
--- /library/bdm/base/libconfig_mex.h (revision 789)
+++ /library/bdm/base/libconfig_mex.h (revision 789)
@@ -0,0 +1,419 @@
+/* ----------------------------------------------------------------------------
+
+	THE FILE IS UNDER THE CONSTRUCTION!
+
+   This file is a mex clone of libconfig.h++ originally found 
+   in the libconfig library which was desgigned by Mark A Lindner
+   
+   ----------------------------------------------------------------------------
+*/
+
+#ifndef LIBCONFIG_MEX_H
+#define LIBCONFIG_MEX_H
+
+#include <stdio.h>
+#include <string>
+#include <map>
+
+
+struct config_t; // fwd decl
+struct config_setting_t; // fwd decl
+
+namespace libconfig {
+
+class ConfigException : public std::exception { };
+
+class Setting; // fwd decl
+
+class SettingException : public ConfigException
+{
+  friend class Config;
+
+  public:
+
+  SettingException(const SettingException &other);
+  SettingException& operator=(const SettingException &other);
+
+  virtual ~SettingException() throw();
+
+  const char *getPath() const;
+
+  virtual const char *what() const throw();
+
+  protected:
+
+  SettingException(const Setting &setting);
+  SettingException(const Setting &setting, int idx);
+  SettingException(const Setting &setting, const char *name);
+  SettingException(const char *path);
+
+  private:
+
+  char *_path;
+};
+
+class SettingTypeException : public SettingException
+{
+  friend class Config;
+  friend class Setting;
+
+  public:
+
+  const char *what() const throw();
+
+  private:
+
+  SettingTypeException(const Setting &setting);
+  SettingTypeException(const Setting &setting, int idx);
+  SettingTypeException(const Setting &setting, const char *name);
+};
+
+class SettingNotFoundException : public SettingException
+{
+  friend class Config;
+  friend class Setting;
+
+  public:
+
+  const char *what() const throw();
+
+  private:
+
+  SettingNotFoundException(const Setting &setting, int idx);
+  SettingNotFoundException(const Setting &setting, const char *name);
+  SettingNotFoundException(const char *path);
+};
+
+class SettingNameException : public SettingException
+{
+  friend class Config;
+  friend class Setting;
+
+  public:
+
+  const char *what() const throw();
+
+  private:
+
+  SettingNameException(const Setting &setting, const char *name);
+};
+
+class FileIOException : public ConfigException
+{
+  public:
+
+  const char *what() const throw();
+};
+
+class ParseException : public ConfigException
+{
+  friend class Config;
+
+  public:
+
+  virtual ~ParseException() throw();
+
+  inline const char *getFile() const throw()
+  { return(_file); }
+
+  inline int getLine() const throw()
+  { return(_line); }
+
+  inline const char *getError() const throw()
+  { return(_error); }
+
+  const char *what() const throw();
+
+  private:
+
+  ParseException(const char *file, int line, const char *error);
+
+  const char *_file;
+  int _line;
+  const char *_error;
+};
+
+class Setting
+{
+  friend class Config;
+
+  public:
+
+  enum Type
+  {
+    TypeNone = 0,
+    // scalar types
+    TypeInt,
+    TypeInt64,
+    TypeFloat,
+    TypeString,
+    TypeBoolean,
+    // aggregate types
+    TypeGroup,
+    TypeArray,
+    TypeList
+  };
+
+  enum Format
+  {
+    FormatDefault = 0,
+    FormatHex = 1
+  };
+
+  private:
+
+  config_setting_t *_setting;
+  Type _type;
+  Format _format;
+
+  Setting(config_setting_t *setting);
+
+  void assertType(Type type) const
+    throw(SettingTypeException);
+  static Setting & wrapSetting(config_setting_t *setting);
+
+  Setting(const Setting& other); // not supported
+  Setting& operator=(const Setting& other); // not supported
+
+  public:
+
+  virtual ~Setting() throw();
+
+  inline Type getType() const throw() { return(_type); }
+
+  inline Format getFormat() const throw() { return(_format); }
+  void setFormat(Format format) throw();
+
+  operator bool() const throw(SettingTypeException);
+  operator int() const throw(SettingTypeException);
+  operator unsigned int() const throw(SettingTypeException);
+  operator long() const throw(SettingTypeException);
+  operator unsigned long() const throw(SettingTypeException);
+  operator long long() const throw(SettingTypeException);
+  operator unsigned long long() const throw(SettingTypeException);
+  operator double() const throw(SettingTypeException);
+  operator float() const throw(SettingTypeException);
+  operator const char *() const throw(SettingTypeException);
+  operator std::string() const throw(SettingTypeException);
+
+  Setting & operator=(bool value) throw(SettingTypeException);
+  Setting & operator=(int value) throw(SettingTypeException);
+  Setting & operator=(long value) throw(SettingTypeException);
+  Setting & operator=(const long long &value) throw(SettingTypeException);
+  Setting & operator=(const double &value) throw(SettingTypeException);
+  Setting & operator=(float value) throw(SettingTypeException);
+  Setting & operator=(const char *value) throw(SettingTypeException);
+  Setting & operator=(const std::string &value) throw(SettingTypeException);
+
+  Setting & operator[](const char * key) const
+    throw(SettingTypeException, SettingNotFoundException);
+
+  inline Setting & operator[](const std::string & key) const
+    throw(SettingTypeException, SettingNotFoundException)
+  { return(operator[](key.c_str())); }
+
+  Setting & operator[](int index) const
+    throw(SettingTypeException, SettingNotFoundException);
+
+  bool lookupValue(const char *name, bool &value) const throw();
+  bool lookupValue(const char *name, int &value) const throw();
+  bool lookupValue(const char *name, unsigned int &value) const throw();
+  bool lookupValue(const char *name, long long &value) const throw();
+  bool lookupValue(const char *name, unsigned long long &value)
+    const throw();
+  bool lookupValue(const char *name, double &value) const throw();
+  bool lookupValue(const char *name, float &value) const throw();
+  bool lookupValue(const char *name, const char *&value) const throw();
+  bool lookupValue(const char *name, std::string &value) const throw();
+
+  inline bool lookupValue(const std::string &name, bool &value)
+    const throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &name, int &value)
+    const throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &name, unsigned int &value)
+    const throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &name, long long &value)
+    const throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &name,
+                          unsigned long long &value) const throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &name, double &value) const
+    throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &name, float &value) const
+    throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &name, const char *&value) const
+    throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &name, std::string &value) const
+    throw()
+  { return(lookupValue(name.c_str(), value)); }
+
+  void remove(const char *name)
+    throw(SettingTypeException, SettingNotFoundException);
+
+  inline void remove(const std::string & name)
+    throw(SettingTypeException, SettingNotFoundException)
+  { remove(name.c_str()); }
+
+  void remove(unsigned int idx)
+    throw(SettingTypeException, SettingNotFoundException);
+
+  inline Setting & add(const std::string & name, Type type)
+    throw(SettingNameException, SettingTypeException)
+  { return(add(name.c_str(), type)); }
+
+  Setting & add(const char *name, Type type)
+    throw(SettingNameException, SettingTypeException);
+
+  Setting & add(Type type) throw(SettingTypeException);
+
+  inline bool exists(const std::string & name) const throw()
+  { return(exists(name.c_str())); }
+
+  bool exists(const char *name) const throw();
+
+  int getLength() const throw();
+  const char *getName() const throw();
+  std::string getPath() const;
+  int getIndex() const throw();
+
+  const Setting & getParent() const throw(SettingNotFoundException);
+  Setting & getParent() throw(SettingNotFoundException);
+
+  bool isRoot() const throw();
+
+  inline bool isGroup() const throw()
+  { return(_type == TypeGroup); }
+
+  inline bool isArray() const throw()
+  { return(_type == TypeArray); }
+
+  inline bool isList() const throw()
+  { return(_type == TypeList); }
+
+  inline bool isAggregate() const throw()
+  { return(_type >= TypeGroup); }
+
+  inline bool isScalar() const throw()
+  { return((_type > TypeNone) && (_type < TypeGroup)); }
+
+  inline bool isNumber() const throw()
+  { return((_type == TypeInt) || (_type == TypeInt64)
+           || (_type == TypeFloat)); }
+
+  unsigned int getSourceLine() const throw();
+  const char *getSourceFile() const throw();
+};
+
+class Config
+{
+  private:
+
+  config_t *_config;
+
+  static void ConfigDestructor(void *arg);
+  Config(const Config& other); // not supported
+  Config& operator=(const Config& other); // not supported
+
+  public:
+
+  Config();
+  virtual ~Config();
+
+  void setAutoConvert(bool flag);
+  bool getAutoConvert() const;
+
+  void setTabWidth(unsigned short width) throw();
+  unsigned short getTabWidth() const throw();
+
+  void read(FILE *stream) throw(ParseException);
+  void write(FILE *stream) const;
+
+  void readString(const char *str) throw(ParseException);
+  inline void readString(const std::string &str) throw(ParseException)
+  { return(readString(str.c_str())); }
+
+  void readFile(const char *filename) throw(FileIOException, ParseException);
+  void writeFile(const char *filename) throw(FileIOException);
+
+  inline Setting & lookup(const std::string &path) const
+    throw(SettingNotFoundException)
+  { return(lookup(path.c_str())); }
+
+  Setting & lookup(const char *path) const throw(SettingNotFoundException);
+
+  inline bool exists(const std::string & path) const throw()
+  { return(exists(path.c_str())); }
+
+  bool exists(const char *path) const throw();
+
+  bool lookupValue(const char *path, bool &value) const throw();
+  bool lookupValue(const char *path, int &value) const throw();
+  bool lookupValue(const char *path, unsigned int &value) const throw();
+  bool lookupValue(const char *path, long long &value) const throw();
+  bool lookupValue(const char *path, unsigned long long &value)
+    const throw();
+  bool lookupValue(const char *path, double &value) const throw();
+  bool lookupValue(const char *path, float &value) const throw();
+  bool lookupValue(const char *path, const char *&value) const throw();
+  bool lookupValue(const char *path, std::string &value) const throw();
+
+  inline bool lookupValue(const std::string &path, bool &value) const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &path, int &value) const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &path, unsigned int &value)
+    const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &path, long long &value)
+    const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &path,
+                          unsigned long long &value) const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &path, double &value)
+    const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &path, float &value)
+    const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &path, const char *&value)
+    const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  inline bool lookupValue(const std::string &path, std::string &value)
+    const throw()
+  { return(lookupValue(path.c_str(), value)); }
+
+  Setting & getRoot() const;
+
+  private:
+
+  void handleError() const;
+};
+
+}; // namespace libconfig
+
+
+#endif // LIBCONFIG_MEX_H
Index: /library/bdm/stat/emix.cpp
===================================================================
--- /library/bdm/stat/emix.cpp (revision 784)
+++ /library/bdm/stat/emix.cpp (revision 789)
@@ -31,6 +31,4 @@
 		w = 1.0 / len;
 	}
-
-	validate();
 }
 
Index: /library/bdm/CMakeLists.txt
===================================================================
--- /library/bdm/CMakeLists.txt (revision 693)
+++ /library/bdm/CMakeLists.txt (revision 789)
@@ -8,6 +8,6 @@
 SET(bdm_estim estim/kalman.cpp estim/kalman.h estim/particles.cpp estim/particles.h estim/arx.cpp estim/arx.h estim/arx_straux.cpp estim/mixtures.cpp estim/mixtures.h)
 SET(bdm_ctrl design/ctrlbase.cpp design/ctrlbase.h)
-SET(bdm_user_info base/libconfig/lib/libconfigcpp.cc base/libconfig/lib/grammar.c base/libconfig/lib/libconfig.c 
-	base/libconfig/lib/libconfig.h base/libconfig/lib/libconfig.hh base/libconfig/lib/scanner.c  base/user_info.cpp base/user_info.h  base/libconfig/lib/parsectx.h base/libconfig/lib/scanctx.c base/libconfig/lib/scanctx.h  base/libconfig/lib/strbuf.h 
+SET(bdm_user_info base/libconfig/lib/libconfigcpp.cc base/libconfig/lib/grammar.c base/libconfig/lib/libconfig.c base/libconfig_mex.h base/libconfig_mex.cpp 
+base/libconfig/lib/libconfig.h base/libconfig/lib/libconfig.hh base/libconfig/lib/scanner.c  base/user_info.cpp base/user_info.h  base/libconfig/lib/parsectx.h base/libconfig/lib/scanctx.c base/libconfig/lib/scanctx.h  base/libconfig/lib/strbuf.h 
 base/libconfig/lib/strbuf.c)
 
